install.packages("matrixStats")
install.packages("glmnet")
library(matrixStats)
library(glmnet)
install.packages("remotes")
remotes::install_github("sahirbhatnagar/ggmix")
library("ggmix")



#Expset is the set of explanatory variables and y1 is the dependent vector.

#Creation of all possible pairwise differences between individuals.

HEset <- cbind(y1,expset)
HEset <- HEset[order(HEset[,1]),]
foo <- t(HEset)
cols <- combn( ncol(foo), 2)
Pairdiff <- apply( cols, 2, function(z) rowDiffs(foo[,z]))
HEset <- t(Pairdiff)
# Pairwise differences of phenotype values between all individuals.
HEpheno2 <- HEset[,1]
HEexpset <- HEset[,-1]
# Creation of pseudo-explanatory variables with the gamma-parameter equal to 0.2 in the powered exponential kernel.
v1 <- (abs(HEexpset))^0.2
pred1 <- (-v1);

v2 <- (abs(HEexpset))^1
pred2 <- (-v2);


v3 <- (abs(HEexpset))^2
pred3 <- (-v3);

# Estimation of the expression covariance matrices based on the pseudo-variables.
b1 <- cov(t(pred1))
b2 <- cov(t(pred2))
b3 <- cov(t(pred3))

fit_1 <- ggmix(x=as.matrix(pred1), y=log(HEpheno2^2), kinship = b1, alpha = 1/3, lambda_min_ratio =0.1)
fit_2 <- ggmix(x=as.matrix(pred2), y=log(HEpheno2^2), kinship = b2, alpha = 1/3, lambda_min_ratio =0.1)
fit_3 <- ggmix(x=as.matrix(pred3), y=log(HEpheno2^2), kinship = b3, alpha = 1/3,lambda_min_ratio =0.1)






